---
title: Data security findings timeseries
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/typescript)

[Analytics Query](https://developers.cloudflare.com/api/typescript/resources/analytics_query)

[Data Security](https://developers.cloudflare.com/api/typescript/resources/analytics_query/subresources/data_security)

[Findings](https://developers.cloudflare.com/api/typescript/resources/analytics_query/subresources/data_security/subresources/findings)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Data security findings timeseries

client.analyticsQuery.dataSecurity.findings.timeseries(FindingTimeseriesParams {account\_id, filters, from, to } params, RequestOptionsoptions?): [FindingTimeseriesResponse](<https://developers.cloudflare.com/api/typescript/resources/analytics_query#(resource)%20analytics_query.data_security.findings%20%3E%20(model)%20finding_timeseries_response%20%3E%20(schema)>) {slots, resolution }

POST/accounts/{account\_id}/analytics/query/data-security/findings/timeseries

Returns merged time-bucketed CASB findings.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`Zero Trust Read`

##### ParametersExpand Collapse

<details>

<summary>

params: FindingTimeseriesParams {account\_id, filters, from, to }

</summary>

account\_id: string

Path param: Cloudflare account identifier.

maxLength32

<a href="#(resource)%20analytics_query.data_security.findings%20%3E%20(method)%20timeseries%20%3E%20(params)%20default%20%3E%20(param)%20account_id">Link to this property</a>

<details>

<summary>

filters: Array&lt;Filter&gt;

Body param: Filters to apply.

</summary>

name: string

Specifies the column name to filter on. Requires a valid column for the target dataset (e.g. <code>country</code>, <code>allowed</code>, <code>appId</code>).

<a href="#(resource)%20analytics_query.data_security.findings%20%3E%20(method)%20timeseries%20%3E%20(params)%20default%20%3E%20(param)%20filters%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20name">Link to this property</a>

op: string

Filter operator. Common values: <code>eq</code>, <code>neq</code>, <code>in</code>, <code>not_in</code>, <code>gt</code>, <code>lt</code>, <code>gte</code>, <code>lte</code>.

<a href="#(resource)%20analytics_query.data_security.findings%20%3E%20(method)%20timeseries%20%3E%20(params)%20default%20%3E%20(param)%20filters%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20op">Link to this property</a>

<details>

<summary>

values: Array&lt;string| boolean| number&gt;

Values to match against. Type depends on the column.

</summary>

One of the following:

string

<a href="#(resource)%20analytics_query.data_security.findings%20%3E%20(method)%20timeseries%20%3E%20(params)%20default%20%3E%20(param)%20filters%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20values%20%3E%20(items)%20%3E%20(variant)%200">Link to this property</a>

boolean

<a href="#(resource)%20analytics_query.data_security.findings%20%3E%20(method)%20timeseries%20%3E%20(params)%20default%20%3E%20(param)%20filters%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20values%20%3E%20(items)%20%3E%20(variant)%201">Link to this property</a>

number

<a href="#(resource)%20analytics_query.data_security.findings%20%3E%20(method)%20timeseries%20%3E%20(params)%20default%20%3E%20(param)%20filters%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20values%20%3E%20(items)%20%3E%20(variant)%202">Link to this property</a>

</details>

<a href="#(resource)%20analytics_query.data_security.findings%20%3E%20(method)%20timeseries%20%3E%20(params)%20default%20%3E%20(param)%20filters%20%3E%20(schema)%20%3E%20(items)%20%3E%20(property)%20values">Link to this property</a>

</details>

<a href="#(resource)%20analytics_query.data_security.findings%20%3E%20(method)%20timeseries%20%3E%20(params)%20default%20%3E%20(param)%20filters">Link to this property</a>

from: string

Body param: Start of the query time range (inclusive). RFC3339.

formatdate-time

<a href="#(resource)%20analytics_query.data_security.findings%20%3E%20(method)%20timeseries%20%3E%20(params)%20default%20%3E%20(param)%20from">Link to this property</a>

to: string

Body param: End of the query time range (exclusive). RFC3339.

formatdate-time

<a href="#(resource)%20analytics_query.data_security.findings%20%3E%20(method)%20timeseries%20%3E%20(params)%20default%20%3E%20(param)%20to">Link to this property</a>

</details>

[Link to this property](<#(resource)%20analytics_query.data_security.findings%20%3E%20(method)%20timeseries%20%3E%20(params)%20default>)

##### ReturnsExpand Collapse

<details>

<summary>

FindingTimeseriesResponse {slots, resolution }

Merged CASB and CDE findings timeseries result.

</summary>

slots: Array&lt;Record&lt;string, unknown&gt;&gt;

Contains time-bucketed result rows. Each slot includes a <code>timestamp</code> plus <code>content</code> and <code>posture</code> maps with <code>cloud</code> and <code>saas</code> keys.

<a href="#(resource)%20analytics_query.data_security.findings%20%3E%20(model)%20finding_timeseries_response%20%3E%20(schema)%20%3E%20(property)%20slots">Link to this property</a>

resolution?: string| null

Always null for this endpoint.

<a href="#(resource)%20analytics_query.data_security.findings%20%3E%20(model)%20finding_timeseries_response%20%3E%20(schema)%20%3E%20(property)%20resolution">Link to this property</a>

</details>

[Link to this property](<#(resource)%20analytics_query.data_security.findings%20%3E%20(model)%20finding_timeseries_response%20%3E%20(schema)>)

### Data security findings timeseries

TypeScript

HTTPTypeScriptPythonGoTerraform

```
import Cloudflare from 'cloudflare';

const client = new Cloudflare({
  apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted
});

const response = await client.analyticsQuery.dataSecurity.findings.timeseries({
  account_id: '023e105f4ecef8ad9ca31a8372d0c353',
  filters: [],
  from: '2024-11-01T00:00:00Z',
  to: '2024-11-08T00:00:00Z',
});

console.log(response.slots);
```

200 example

400 example

400 example

403 example

```
{
  "errors": [],
  "messages": [
    {
      "code": 1000,
      "message": "API in beta: expect breaking changes."
    }
  ],
  "result": {
    "slots": [
      {
        "content": {
          "cloud": 150,
          "saas": 23
        },
        "posture": {
          "cloud": 0,
          "saas": 5
        },
        "timestamp": "2024-11-05T00:00:00Z"
      },
      {
        "content": {
          "cloud": 180,
          "saas": 30
        },
        "posture": {
          "cloud": 0,
          "saas": 7
        },
        "timestamp": "2024-11-06T00:00:00Z"
      }
    ]
  },
  "success": true
}
```

```
{
  "errors": [
    {
      "code": 11005,
      "message": "art.api.parameter.invalid"
    }
  ],
  "messages": [
    {
      "code": 1002,
      "message": "Parameter 'from' has invalid value '2024-11-05 00:00:00'. Should be of type: 'RFC3339'"
    }
  ],
  "result": null,
  "success": false
}
```

```
{
  "errors": [
    {
      "code": 11005,
      "message": "art.api.parameter.invalid"
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "API in beta: expect breaking changes."
    }
  ],
  "result": null,
  "success": false
}
```

```
{
  "errors": [
    {
      "code": 11003,
      "message": "art.api.resource.insufficient_permissions"
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "API in beta: expect breaking changes."
    }
  ],
  "result": null,
  "success": false
}
```

##### Returns Examples

200 example

400 example

400 example

403 example

```
{
  "errors": [],
  "messages": [
    {
      "code": 1000,
      "message": "API in beta: expect breaking changes."
    }
  ],
  "result": {
    "slots": [
      {
        "content": {
          "cloud": 150,
          "saas": 23
        },
        "posture": {
          "cloud": 0,
          "saas": 5
        },
        "timestamp": "2024-11-05T00:00:00Z"
      },
      {
        "content": {
          "cloud": 180,
          "saas": 30
        },
        "posture": {
          "cloud": 0,
          "saas": 7
        },
        "timestamp": "2024-11-06T00:00:00Z"
      }
    ]
  },
  "success": true
}
```

```
{
  "errors": [
    {
      "code": 11005,
      "message": "art.api.parameter.invalid"
    }
  ],
  "messages": [
    {
      "code": 1002,
      "message": "Parameter 'from' has invalid value '2024-11-05 00:00:00'. Should be of type: 'RFC3339'"
    }
  ],
  "result": null,
  "success": false
}
```

```
{
  "errors": [
    {
      "code": 11005,
      "message": "art.api.parameter.invalid"
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "API in beta: expect breaking changes."
    }
  ],
  "result": null,
  "success": false
}
```

```
{
  "errors": [
    {
      "code": 11003,
      "message": "art.api.resource.insufficient_permissions"
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "API in beta: expect breaking changes."
    }
  ],
  "result": null,
  "success": false
}
```